//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Silver
#property indicator_color2  Silver
#property indicator_color3  Silver
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_color4  DeepSkyBlue
#property indicator_color5  Red
#property indicator_color6  Red

//
//
//
//
//

extern int    SF          = 5;
extern int    RSIPeriod   = 14;
extern int    RSIPrice    = PRICE_CLOSE;
extern double WP          = 4.236;
//
//
//
//
//

double TrendU[];
double TrendDa[];
double TrendDb[];
double RsiMa[];
double RsiMaDa[];
double RsiMaDb[];
double TrendQqe[];
double TrendQqs[];
double emas[][3];
double ma[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,RsiMa);    SetIndexLabel(0, "QQE");
   SetIndexBuffer(1,RsiMaDa);  SetIndexLabel(1, "QQE down");
   SetIndexBuffer(2,RsiMaDb);  SetIndexLabel(2, "QQE down");
   SetIndexBuffer(3,TrendU);   SetIndexLabel(1, "QQE trend up");
   SetIndexBuffer(4,TrendDa);  SetIndexLabel(2, "QQE trend down");
   SetIndexBuffer(5,TrendDb);  SetIndexLabel(2, "QQE trend down");
   IndicatorShortName("QQE ("+SF+","+RSIPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iEma 0
#define iEmm 1
#define iQqe 2

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = Bars-counted_bars;
           if (ArrayRange(emas,0) != Bars) { ArrayResize(emas,Bars); ArrayResize(TrendQqe,Bars); ArrayResize(TrendQqs,Bars); ArrayResize(ma,Bars); }
           if (TrendQqe[Bars-limit-1]==-1) CleanPoint(limit,RsiMaDa,RsiMaDb);
           if (TrendQqs[Bars-limit-1]==-1) CleanPoint(limit,TrendDa,TrendDb);

   //
   //
   //
   //
   //

   double alpha1 = 2.0/(SF+1.0);
   double alpha2 = 2.0/(RSIPeriod*2.0);
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {  
      ma[r] = iMA(NULL,0,1,0,MODE_SMA,RSIPrice,i);
         double up     = 0;
         double down   = 0;
         double diff   = 0;
         double tmpRsi = 0;
         for(int k=0; k<RSIPeriod; k++)
         {
            diff = ma[r-k]-ma[r-k-1];
            if(diff>0)
                  up   += diff;
            else  down -= diff;
         }
         if(up+down== 0)
               tmpRsi = 50.0;
         else  tmpRsi = 100.0 * up / (up + down);         
   
      //
      //
      //
      //
      //
         
      RsiMa[i]   = RsiMa[i+1] + alpha1*(tmpRsi - RsiMa[i+1]);
      emas[r][iEma] = emas[r-1][iEma] + alpha2*(MathAbs(RsiMa[i+1]-RsiMa[i]) - emas[r-1][iEma]);
      emas[r][iEmm] = emas[r-1][iEmm] + alpha2*(emas[r][iEma] - emas[r-1][iEmm]);

      //
      //
      //
      //
      //

         double rsi0 = RsiMa[i];
         double rsi1 = RsiMa[i+1];
         double dar  = emas[r  ][iEmm]*WP;
         double tr   = emas[r-1][iQqe];
         double dv   = tr;
   
            if (rsi0 < tr) { tr = rsi0 + dar; if ((rsi1 < dv) && (tr > dv)) tr = dv; }
            if (rsi0 > tr) { tr = rsi0 - dar; if ((rsi1 > dv) && (tr < dv)) tr = dv; }
         
      //
      //
      //
      //
      //
         
         TrendU[i]     = tr;
         emas[r][iQqe] = tr;
         TrendDa[i]    = EMPTY_VALUE;
         TrendDb[i]    = EMPTY_VALUE;
         RsiMaDa[i]    = EMPTY_VALUE;
         RsiMaDb[i]    = EMPTY_VALUE;
         TrendQqe[r]   = TrendQqe[r-1];
         TrendQqs[r]   = TrendQqs[r-1];

            if (RsiMa[i]>RsiMa[i+1]) TrendQqe[r] =  1;
            if (RsiMa[i]<RsiMa[i+1]) TrendQqe[r] = -1;
            if (tr     < RsiMa[i]  ) TrendQqs[r] =  1;
            if (tr     > RsiMa[i]  ) TrendQqs[r] = -1;

         if (TrendQqe[r] == -1) PlotPoint(i,RsiMaDa,RsiMaDb,RsiMa);
         if (TrendQqs[r] == -1) PlotPoint(i,TrendDa,TrendDb,TrendU);
   }    

   //
   //
   //
   //
   //
       
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}